using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using System.IO;
 
namespace ADX_IE_Protected_Mode_API_CS
{
    /// <summary>
    /// Add-in Express .NET for Internet Explorer Bar
    /// </summary>
    [ComVisible(true), Guid("9427799F-7275-4230-9F0B-1D77F504F567")]
    public class IEToolBarModule : AddinExpress.IE.ADXIEToolbarModule
    {
        public IEToolBarModule()
        {
            InitializeComponent();
        }

		private Button buttonSave;
		private Label label1;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.buttonSave = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonSave
			// 
			this.buttonSave.Location = new System.Drawing.Point(3, 3);
			this.buttonSave.Name = "buttonSave";
			this.buttonSave.Size = new System.Drawing.Size(131, 23);
			this.buttonSave.TabIndex = 1;
			this.buttonSave.Text = "Save User\'s Data";
			this.buttonSave.UseVisualStyleBackColor = true;
			this.buttonSave.Click += new System.EventHandler(this.buttonSave_Click);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(150, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(35, 13);
			this.label1.TabIndex = 2;
			this.label1.Text = "label1";
			// 
			// IEToolBarModule
			// 
			this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonSave);
			this.HelpText = "ADX IE Protected Mode API Toolbar";
			this.MenuText = "ADX IE Protected Mode API Toolbar";
			this.Name = "IEToolBarModule";
			this.Size = new System.Drawing.Size(300, 30);
			this.OnDisconnect += new System.EventHandler(this.IEToolBarModule_OnDisconnect);
			this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.IEToolBarModule_OnConnect);
			this.ResumeLayout(false);
			this.PerformLayout();

        }
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void RegisterIEToolbarModule(Type t)
        {
            AddinExpress.IE.ADXIEToolbarModule.RegisterIEToolbarModuleInternal(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEToolbarModule(Type t)
        {
            AddinExpress.IE.ADXIEToolbarModule.UnregisterIEToolbarModuleInternal(t);
        }
 
        #endregion
 
        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }
 
        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

		private AddinExpress.IE.ADXIEProtectedModeAPI pAPI = null;

		private void IEToolBarModule_OnConnect(object sender, int threadId)
		{
			try
			{
				this.pAPI = new AddinExpress.IE.ADXIEProtectedModeAPI();
				bool pmState = this.pAPI.IsProtectedModeOn();
				this.label1.Text = (pmState ? "Protected Mode: On" : "Protected Mode: Off");
			}
			catch (Exception err)
			{
				MessageBox.Show(err.Message, this.MenuText, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void IEToolBarModule_OnDisconnect(object sender, EventArgs e)
		{
			if (this.pAPI != null)
				this.pAPI.Dispose();
		}

		private void buttonSave_Click(object sender, EventArgs e)
		{
			string tempFilePath = string.Empty;
			try
			{
				if (this.pAPI != null)
				{
					int state = 0;
					string fileName = this.pAPI.ShowSaveFileDialog(this.TabWindowHandle, "SavedLog.txt", null, "Text files|*.txt|All files|*.*|", "txt", 1,
						AddinExpress.IE.ADXIEOpenFileNameFlags.ofnEnableSizing | AddinExpress.IE.ADXIEOpenFileNameFlags.ofnHideReadOnly |
						AddinExpress.IE.ADXIEOpenFileNameFlags.ofnPathMustExist | AddinExpress.IE.ADXIEOpenFileNameFlags.ofnOverWritePrompt, ref state);
					if (state != 0)
					{
						try
						{
							tempFilePath = this.pAPI.GetWriteableFolderPath();
							tempFilePath = Path.Combine(tempFilePath, "IEProtectedModeAPI");
							if (!Directory.Exists(tempFilePath))
								Directory.CreateDirectory(tempFilePath);

							tempFilePath = Path.Combine(tempFilePath, "mylog.txt");

							using (StreamWriter sw = new StreamWriter(tempFilePath, false))
							{
								sw.WriteLine("IEProtectedModeAPI Example");
								sw.WriteLine("--------------------------");
								sw.WriteLine("This is just a test.");
							}

							if (!File.Exists(tempFilePath))
								throw new FileNotFoundException("The log file doesn't exist.");

							this.pAPI.SaveFile(state, tempFilePath);

							MessageBox.Show(this, "The file has been successfully saved.", this.MenuText, MessageBoxButtons.OK, MessageBoxIcon.Information);
						}
						catch
						{
							this.pAPI.CancelSaveFile(state);
							throw;
						}
					}
				}
			}
			catch (Exception err)
			{
				MessageBox.Show(this, err.Message, this.MenuText, MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
			finally
			{
				if (tempFilePath != string.Empty)
					if (File.Exists(tempFilePath))
						File.Delete(tempFilePath);
			}
		}
    }
}

